package cc.smtweb.system.bpm.web.design.form;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.annotation.SwBody;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.core.mvc.service.*;
import cc.smtweb.framework.core.session.UserSession;

/**
 * Created by Akmm at 2022/3/22 9:12
 */
@SwService
public class ModelFormService extends AbstractCompService {
    @Override
    protected IHandler createHandler(String type) {
        switch (type) {
            case TYPE_LOAD:
                return new ModelFormLoadHandler();
            case TYPE_SAVE:
                return new ModelFormSaveHandler();
            case TYPE_DEL:
                return new DefaultDelHandler<ModelForm>(ModelForm.ENTITY_NAME);
            case TYPE_LIST:
                return new DefaultListHandler<ModelForm>(ModelForm.ENTITY_NAME);

        }
        return null;
    }

    //保存数据集
    public R saveDataset(@SwBody SwMap params, UserSession us) {
        try {
            ModelFormSaveHandler handler = (ModelFormSaveHandler) getHandler(params, us, TYPE_SAVE);
            return handler.saveDataset();
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }

    //加载数据集
    public R loadDataset(@SwBody SwMap params, UserSession us) {
        try {
            ModelFormLoadHandler handler = (ModelFormLoadHandler) getHandler(params, us, TYPE_LOAD);
            return handler.loadDataset();
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }

    //保存页面模型
    public R saveModel(@SwBody SwMap params, UserSession us) {
        try {
            ModelFormSaveHandler handler = (ModelFormSaveHandler) getHandler(params, us, TYPE_SAVE);
            return handler.saveModel();
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }

    //加载页面模型
    public R loadModel(@SwBody SwMap params, UserSession us) {
        try {
            ModelFormLoadHandler handler = (ModelFormLoadHandler) getHandler(params, us, TYPE_LOAD);
            return handler.loadModel();
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }

    //加载引擎用页面模型
    public R model(@SwBody SwMap params, UserSession us) {
        try {
            ModelFormLoadHandler handler = (ModelFormLoadHandler) getHandler(params, us, TYPE_LOAD);
            return handler.loadForm();
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }

    //获取页面使用的控件的filter信息
    public R loadWidgetFilter(@SwBody SwMap params, UserSession us) {
        try {
            ModelFormLoadHandler handler = (ModelFormLoadHandler) getHandler(params, us, TYPE_LOAD);
            return handler.loadWidgetFilter();
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }
}
